Attribute VB_Name = "FrmCopyFilebas"
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Public Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    FLAGS As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type


'Public DeClare Virables
Public dB As Database
Public Rs As Recordset
Public fName As Recordset
Public DbPath As String
Public Cat As String
Public FileName As String
Public Ace As String

Public msDrive As String
Public msPath As String
Public msFile As String
Public msExt As String
Public msName As String
'
'

'Function to Open DataBase
'

Public Function OB(DbPath)

'incase Not Exist Want Kill Program
On Error GoTo Bad

Set dB = OpenDatabase(DbPath)

Exit Function

Bad:
MsgBox "Had Trouble With DataBase"

End Function

'Function to File FrmCopyFile Combo1 With RecordSets
'

Public Function FillCombox()

'Clear Combo1 Box
FrmCopyFile.Combo1.Clear

With dB
        For Each Table In .TableDefs
        If Table.Name = "MSysACEs" Then GoTo 11
        If Table.Name = "MSysModules" Then GoTo 11
        If Table.Name = "MSysModules2" Then GoTo 11
        If Table.Name = "MSysObjects" Then GoTo 11
        If Table.Name = "MSysQueries" Then GoTo 11
        If Table.Name = "MSysRelationships" Then GoTo 11
        If Table.Name = "MSysAccessObjects" Then GoTo 11
                    FrmCopyFile.Combo1.AddItem Trim(Table.Name)
11
        Next Table
    End With
    
    'Table Name to Show in Combo1
    FrmCopyFile.Combo1.Text = FrmCopyFile.Combo1.List(0)
    
    
End Function

'Function to Open RecordSet
'

Public Function Ors()

'incase Fields Not Found Want Kill Program
On Error GoTo Bad

Set Rs = dB.OpenRecordset(Cat)

Exit Function

Bad:
MsgBox "Had Trouble With RecordSet"

End Function

'Function to fill ListBox
'

Public Function FileListBox()

'Clear ListBox
FrmCopyFile.List1.Clear

'get FileName in RecordSet
On Error Resume Next 'Just in case No Records in RecordSet
Rs.MoveFirst
For i = 1 To Rs.RecordCount
FrmCopyFile.List1.AddItem Rs.Fields(0).Value & ""
Rs.MoveNext
Next i


End Function
Public Function GetData()

'Get the File Description
'

'Put some Data in Virable FileName
FileName = Trim(FrmCopyFile.List1.Text)

'Move to the FileName Choosen in FrmCopyFile List1 Box
Rs.MoveFirst
For i = 1 To Rs.RecordCount
If Trim(Rs.Fields(0).Value & "") = Trim(FrmCopyFile.List1.Text) Then
FrmCopyFile.Text1 = Trim(Rs.Fields(1).Value & "")
FrmCopyFile.CopyFile.Enabled = True
FrmCopyFile.CopyFile.Caption = "Copy"
FrmCopyFile.CopyFile.Caption = FrmCopyFile.CopyFile.Caption & " (" & FileName & ") to Disk"
Exit Function
Else
End If
Rs.MoveNext
Next

End Function

Public Function GetPath1()
Dim OpenFol As String

    OpenFol = GetFolder1(hwnd, "Choose Path to Save File To")
    Ace = OpenFol
    
    If Ace = "" Then Exit Function

If Right(Ace, 1) = "\" Then
Ace = Ace
Else
Ace = Ace & "\"
End If

msName = ""

FullPath FrmCopyFile.List1.Text

Open Ace & msName & ".txt" For Output As #1

'Open Ace & FileName & ".txt" For Output As #1
Print #1, Trim(FrmCopyFile.Text1.Text)
Close #1

'Copy Field to File
CopyFieldToFile Rs, "File", Ace & FileName

MsgBox FileName & " Copied to " & Ace & FileName
Exit Function

NotYet:
MsgBox "Must Choose a File and a catagory"

End Function

Public Function GetFolder1(ByVal hWndOwner As Long, ByVal sTitle As String) As String
Dim bInf As BROWSEINFO
Dim RetVal As Long
Dim PathID As Long
Dim RetPath As String
Dim Offset As Integer
    bInf.hOwner = hWndOwner
    bInf.lpszTitle = sTitle
    bInf.ulFlags = BIF_RETURNONLYFSDIRS
    PathID = SHBrowseForFolder(bInf)
    RetPath = Space$(512)
    RetVal = SHGetPathFromIDList(ByVal PathID, ByVal RetPath)
    If RetVal Then
      Offset = InStr(RetPath, Chr$(0))
      GetFolder1 = Left$(RetPath, Offset - 1)
    End If
    
    End Function

Public Sub FullPath(sNewFullPath As String)

    Dim iPos As Integer
    Dim iCounter As Integer

    msFullPath = sNewFullPath

    msDrive = ""
    msPath = ""
    msFile = ""
    msExt = ""
    msName = ""
    'Get the Drive
    iPos = InStr(1, msFullPath, ":")
    If iPos > 0 Then  'Drive exists
        msDrive = Left$(msFullPath, iPos)
    End If

    If Right$(msFullPath, 1) = "/" Or _
        Right$(msFullPath, 1) = "\" Or _
        InStr(1, msFullPath, ".") = 0 Then

        'No file specified in this path
        msFile = ""
        msExt = ""
        msPath = msFullPath

        'Append a backslash if one does not exist
        If Right$(msPath, 1) <> "/" And _
            Right$(msPath, 1) <> "\" Then
            
          'Path only
          msPath = msPath & "\"
        End If

    Else

        iPos = Len(msFullPath)
        'Loop backwards through msFullPath _
        'until we have all of the filename
        For iCounter = iPos To 1 Step -1
            If Mid$(msFullPath, iCounter, 1) = "/" _
                Or Mid$(msFullPath, iCounter, 1) = "\" Then
                'No more characters for the file
                Exit For
            Else
                msFile = Mid$(msFullPath, _
                iCounter, 1) & msFile
            End If
        Next

        'Parse out the path without the filename
        
         'Path only
         msPath = Left$(msFullPath, _
                 Len(msFullPath) - Len(msFile))

        'Get the extension
        iPos = InStr(1, msFile, ".")
        
        'Ext. only
        msExt = Right$(msFile, Len(msFile) - iPos)
        
        'FileName No Ext.
        msName = Left$(msFile, Len(msFile) - 4)

    End If
End Sub

Public Function CopyFieldToFile(rst As DAO.Recordset, fd As String, strFileName As String) As String
 Dim FileNum As Integer
 Dim Buffer() As Byte
 Dim BytesNeeded As Long
 Dim Buffers As Long
 Dim Remainder As Long
 Dim Offset As Long
 Dim r As Integer
 Dim i As Long
 Dim ChunkSize As Long

 ChunkSize = 65536
 BytesNeeded = rst(fd).FieldSize
    If BytesNeeded > 0 Then
       ' Calculate the number of buffers needed to copy
        Buffers = BytesNeeded \ ChunkSize
        Remainder = BytesNeeded Mod ChunkSize
        ' Get a unique, temporary filename:

        If Dir(strFileName) <> "" Then
            Kill strFileName
        End If
        ' Copy the file to the file chunk by chunk:
        FileNum = FreeFile
        Open strFileName For Binary As #FileNum
        For i = 0 To Buffers - 1
           ReDim Buffer(ChunkSize)
           Buffer = rst(fd).GetChunk(Offset, ChunkSize)
           Put #FileNum, , Buffer()
           Offset = Offset + ChunkSize
        Next        ' Copy the remaining chunk of the file to the file:
        ReDim Buffer(Remainder)
        Buffer = rst(fd).GetChunk(Offset, Remainder)
        Put #FileNum, , Buffer()
        Close #FileNum
    End If
    CopyFieldToFile = strFileName

End Function

'Function That Starts First to Load Catagories (Tables) and the First RecordSet
'

Public Function Start()
'make CopyFile Button False
FrmCopyFile.CopyFile.Enabled = False

'Give DbPath Virable some Data
DbPath = App.Path & "\SorceCode.mdb"


'Make Sure Virable Cat Has no data
Cat = ""

'Open DataBase
'OB DataBaseName, RecordSet
OB DbPath

FillCombox
    'Give Virable Cat some Data
    Cat = FrmCopyFile.Combo1.Text



'Open RecordSet
'Ors RecordSet 0r TableName
Ors

'Call Function To Fill FrmCopyFile List1 Box
FileListBox



'Call Function to Close DataBase and RecordSet
CB

End Function

'Function To Create a New DataBase on the Fly (USE WITH CARE)
'This will Replace Your DataBase with a New DataBase
'

Public Function CreateNewDB1()

'First Warn User If He/She Continues It Destroy the present DataBase
Dim Msg, Style, Title, Response
Msg = "WARNNING !!!" & vbCrLf & _
"The VB Sorce Code DataBase Will be deleted" & vbCrLf & _
"All of It's Data Will Be DELETED If You If You Continue ?" & vbCrLf & _
"and a New Blank DataBase Created" & vbCrLf & _
"It is Best To BACKUP the DataBase From The Main Menu First" & vbCrLf & _
"DO YOU WANT TO CONTINUE ?"
Style = vbYesNo + vbCritical + vbDefaultButton2
Title = "Create New DataBase"
Response = MsgBox(Msg, Style, Title)
If Response = vbYes Then
'User Choose Yes Start the Create Function
GoTo DoIt
Else
'User Choose NO
Exit Function
End If


DoIt:

'Dim Virables To Create New DataBase
Dim NewDB As Database
Dim NewTable As TableDef
Dim DBName As String

        DBName = App.Path + "\SorceCode.mdb" 'Change to Your Database Name
         
         'If DataBase Exist Then Kill It
        If Dir(DBName) <> "" Then
            Kill DBName
        End If
    
        'Create The Database
        Set NewDB = CreateDatabase(DBName, dbLangGeneral)
                
       'Create Tables in The newly Created DataBase
       'As Many as You Like to Add
       'I use 17 Catagories (Tables) here
       'Use as Many Fields as You Like
       'I only use Three (3) Fields in each Catagory (Table)
        Set NewTable = NewDB.CreateTableDef("API Calls")
    With NewTable
        .Fields.Append .CreateField("Name", dbText) 'First Field
        .Fields.Append .CreateField("Description", dbMemo) 'Second Field
        .Fields.Append .CreateField("File", dbLongBinary) 'Third Field
    End With
        NewDB.TableDefs.Append NewTable
        
        Set NewTable = NewDB.CreateTableDef("DialUp Isp")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
    
         Set NewTable = NewDB.CreateTableDef("Editors")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("File Stuff")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("Games")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("Graphics")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("Home Use")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("Internet Stuff")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("Miscellaneous")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("DataBase Stuff")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
   
        Set NewTable = NewDB.CreateTableDef("Others")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
        
         Set NewTable = NewDB.CreateTableDef("My Personal Use")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
       
        Set NewTable = NewDB.CreateTableDef("Screen Savers")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
       
        Set NewTable = NewDB.CreateTableDef("Sound Stuff")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
       
        Set NewTable = NewDB.CreateTableDef("Systems")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
       
        Set NewTable = NewDB.CreateTableDef("Vb Controlls and Forms")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
       
        Set NewTable = NewDB.CreateTableDef("Windows")
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Description", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
        NewDB.TableDefs.Append NewTable
        
        MsgBox "New DataBase Created"
       
  'Call Function Start to Get New DataBase into Program
  Start
  
End Function

'Function to Create a New Table in the DataBase
'

Public Function CreateNewTb1()

'Ask User for Name of Table
Dim Ms, Title, MyValue
Ms = "Enter Name of Catagory (Table) To add to DataBase"
       
Title = "Add Catagory"   ' Set title.
' Display message, title, and default value.
MyValue = InputBox(Ms, Title)
If MyValue = "" Then Exit Function

'Start Creating New Catagory (Table)
Dim NewTable As TableDef
Dim DBName As String

On Error GoTo 20
        Set dB = OpenDatabase(App.Path & "\SorceCode.mdb")
'Create Table
        Set NewTable = dB.CreateTableDef(MyValue)
                
'Create Fields
    
    With NewTable
        .Fields.Append .CreateField("Name", dbText)
        .Fields.Append .CreateField("Decription", dbMemo)
        .Fields.Append .CreateField("File", dbLongBinary)
    End With
    
        dB.TableDefs.Append NewTable
        MsgBox "Table [ " & MyValue & " ] Appended to DataBase", , "Make Table"
        'Call Function To Reload Catagories so That the New one will be there
        Start
        Exit Function
20
 MsgBox "Table Already Exist"

End Function

Public Function DeleteTable()

End Function

'Function to Close RecordSet and DataBase
'
'
Public Function CB()
'Function to Close Record and DataBase
'

'incase already closed or Not Opened Want Kill Program
On Error Resume Next

Rs.Close
dB.Close

End Function

