Attribute VB_Name = "FrmViewerBas"
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long

Public Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    FLAGS As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type
    
    'Public DeClare Virables
    Public msDrive1 As String
    Public msPath1 As String
    Public msFile1 As String
    Public msExt1 As String
    Public msName1 As String
    '
    '
    
Public Function LoadIt()
    FrmViewer.flgGrid.Clear
    FrmViewer.flgGrid.Cols = 3
    FrmViewer.flgGrid.FixedCols = 0
    FrmViewer.flgGrid.FixedRows = 1
    
    FrmViewer.flgGrid.ColWidth(0) = 3330
    FrmViewer.flgGrid.ColWidth(1) = 1650
    FrmViewer.flgGrid.ColWidth(2) = 11500

    FrmViewer.flgGrid.TextMatrix(0, 0) = "FileName"
    FrmViewer.flgGrid.TextMatrix(0, 1) = "Catagory"
    FrmViewer.flgGrid.TextMatrix(0, 2) = "Description"

DbPath = App.Path & "\SorceCode.mdb"
  Set dB = OpenDatabase(DbPath)

On Error Resume Next

  With dB
        For Each Table In .TableDefs
        If Table.Name = "MSysACEs" Then GoTo 11
        If Table.Name = "MSysModules" Then GoTo 11
        If Table.Name = "MSysModules2" Then GoTo 11
        If Table.Name = "MSysObjects" Then GoTo 11
        If Table.Name = "MSysQueries" Then GoTo 11
        If Table.Name = "MSysRelationships" Then GoTo 11
        If Table.Name = "MSysAccessObjects" Then GoTo 11
        Dim Tn As String
        Tn = Table.Name
     
     Set Rs = dB.OpenRecordset(Table.Name)
          Rs.MoveFirst
          For i = 1 To Rs.RecordCount
        FrmViewer.flgGrid.TextMatrix(FrmViewer.flgGrid.Rows - 1, 0) = Rs.Fields(0).Value & " "
        FrmViewer.flgGrid.TextMatrix(FrmViewer.flgGrid.Rows - 1, 1) = Tn
        FrmViewer.flgGrid.TextMatrix(FrmViewer.flgGrid.Rows - 1, 2) = Rs.Fields(1).Value & " "
         Rs.MoveNext
        FrmViewer.flgGrid.Rows = FrmViewer.flgGrid.Rows + 1
         Next i
         
11
        Next Table
    End With
FrmViewer.flgGrid.Sort = 1

FrmViewer.Text1 = "Total File in Data Base " & FrmViewer.flgGrid.Rows - 1
Rs.Close
dB.Close


End Function

Public Function ViewerClick()

'Dim Virable
Dim Rat As String

'Ask user If He/She wants to Save The File to Disk
Dim Msg, Style, Title, Response
Msg = "Do you want to Save [ " & FrmViewer.flgGrid.TextMatrix(FrmViewer.flgGrid.Row, 0) & " ] to Disk ?"
Style = vbYesNo + vbQuestion + vbDefaultButton2
Title = "What ya Want to Do ?"
Response = MsgBox(Msg, Style, Title)

'Users Responce
If Response = vbYes Then

'Put the Gatagory in the Virable Rat
Rat = FrmViewer.flgGrid.TextMatrix(FrmViewer.flgGrid.Row, 1)

DbPath = App.Path & "\SorceCode.mdb"
  
  'Open DataBase
  Set dB = OpenDatabase(DbPath)
     
     'Open RecordSet
     Set Rs = dB.OpenRecordset(Rat)
     
          'Move to the First Record
          Rs.MoveFirst
          
          'use For Loop to get the Record Choosen
          For i = 1 To Rs.RecordCount
             If Trim(Rs.Fields(0)) = Trim(FrmViewer.flgGrid.TextMatrix(FrmViewer.flgGrid.Row, 0)) Then
                    
                    'Get the Path to save File To
                    OpenFol = GetFolder2(hWnd, "Choose Path to Save File To")
                    Ace = OpenFol

                    'Get the Correct Path
                    If Right(Ace, 1) = "\" Then
                    Ace = Ace
                    Else
                    Ace = Ace & "\"
                    End If
              
              'Copy File from dataBase to File on Disk
              Call CopyFieldToFile(Rs, "File", Ace & Trim(Rs.Fields(0)))
              
              'Get just the FileName with no Description
              FullPath Trim(Rs.Fields(0))
              
              'Copy File Description to Disk
              Open Ace & msName1 & ".txt" For Output As #1
              Print #1, Trim(Rs.Fields(1))
              Close #1
              
              'Let User Know File was Copied to Disk
              MsgBox "Copied " & Trim(Rs.Fields(0)) & " to" & vbCrLf & Ace & Trim(Rs.Fields(0))
              
              'Close ReordSet and DataBase
              Rs.Close
              dB.Close
              Exit For
           Else
           'If the Record Above is not the Record Choosen the move to the Next Record
           Rs.MoveNext
           End If
         Next i
Else
End If

End Function


'Sub To Split FilePathName into Pats
Public Sub FullPath(sNewFullPath As String)

    Dim iPos As Integer
    Dim iCounter As Integer

    msFullPath = sNewFullPath

    'Empty Virables
    msDrive1 = ""
    msPath1 = ""
    msFile1 = ""
    msExt1 = ""
    msName1 = ""
    
    'Get the Drive
    iPos = InStr(1, msFullPath, ":")
    If iPos > 0 Then  'Drive exists
        msDrive1 = Left$(msFullPath, iPos)
    End If

    If Right$(msFullPath, 1) = "/" Or _
        Right$(msFullPath, 1) = "\" Or _
        InStr(1, msFullPath, ".") = 0 Then

        'No file specified in this path
        msFile1 = ""
        msExt1 = ""
        msPath1 = msFullPath

        'Append a backslash if one does not exist
        If Right$(msPath1, 1) <> "/" And _
            Right$(msPath1, 1) <> "\" Then
            
          'Path only
          msPath1 = msPath1 & "\"
        End If

    Else

        iPos = Len(msFullPath)
        'Loop backwards through msFullPath _
        'until we have all of the filename
        For iCounter = iPos To 1 Step -1
            If Mid$(msFullPath, iCounter, 1) = "/" _
                Or Mid$(msFullPath, iCounter, 1) = "\" Then
                'No more characters for the file
                Exit For
            Else
                msFile1 = Mid$(msFullPath, _
                iCounter, 1) & msFile1
            End If
        Next

        'Parse out the path without the filename
        
         'Path only
         msPath1 = Left$(msFullPath, _
                 Len(msFullPath) - Len(msFile1))

        'Get the extension
        iPos = InStr(1, msFile1, ".")
        
        'Ext. only
        msExt1 = Right$(msFile1, Len(msFile1) - iPos)
        
        'FileName No Ext.
        msName1 = Left$(msFile1, Len(msFile1) - 4)

    End If
End Sub

Public Function GetFolder2(ByVal hWndOwner As Long, ByVal sTitle As String) As String
Dim bInf As BROWSEINFO
Dim RetVal As Long
Dim PathID As Long
Dim RetPath As String
Dim Offset As Integer
    bInf.hOwner = hWndOwner
    bInf.lpszTitle = sTitle
    bInf.ulFlags = BIF_RETURNONLYFSDIRS
    PathID = SHBrowseForFolder(bInf)
    RetPath = Space$(512)
    RetVal = SHGetPathFromIDList(ByVal PathID, ByVal RetPath)
    If RetVal Then
      Offset = InStr(RetPath, Chr$(0))
      GetFolder2 = Left$(RetPath, Offset - 1)
    End If
    
    End Function


'Function to Close RecordSet and DataBase
'
'
Public Function CDB()
'Function to Close Record and DataBase
'

'incase already closed or Not Opened Want Kill Program
On Error Resume Next

Rs.Close
dB.Close

End Function
